# This file originally contained the comment:
#   Do not edit -- this file automatically generated by build_v3_dist.
# On the contrary, do not rerun build_v3_dist, this file contains
# custom changes for LSB that should not be overwritten
# This is  the gcc base version:
%define version 3.3.4
Summary:     libstdc++-v3 testsuite packaged to be run under QMTest.
Name:        qmtest_libstdcpp
Packager:    Nathaniel Smith <njs@codesourcery.com>
Copyright:   Various
# This should be the gcc version
Version:     %{version}
Release:     1
Group:       Development/Tools
BuildRoot:   %{_tmppath}/%{name}-buildroot
Source:      qmtest_libstdcpp-%{version}.tar.gz
Patch0:      abi_check.patch
Vendor:      CodeSourcery LLC
# If we let RPM detect dependencies, it will get the idea that this
# package requires a specific version of libstdc++.so, and that is
# unhelpful:
AutoReqProv: no
Prefix: /opt/lsb/test
Requires: qm
BuildRequires: qm

%description
This package includes the libstdc++-v3 testsuite from gcc version
%{version}, together with QMTest extensions allowing the testsuite
to be run against an installed version of libstdc++ without
requiring a compiler.

%prep
%setup -q
%patch -p1

%build

%install
rm -rf $RPM_BUILD_ROOT

# We do the building first, because some of the files generated will be
# installed later.
PATH=$PATH:/opt/lsb/bin:/opt/lsb/appbat/bin
PKGROOT=/opt/lsb/test/share/qmtest_libstdcpp_%{version}
%ifarch ppc64 s390x x86_64
  EXECROOT=/opt/lsb/test/lib64/qmtest_libstdcpp_%{version}
%else
  EXECROOT=/opt/lsb/test/lib/qmtest_libstdcpp_%{version}
%endif
LIBDIR=$RPM_BUILD_ROOT/$EXECROOT
mkdir -p `dirname $LIBDIR`
./build_binary_testsuite $LIBDIR lsbc++ %{_sourcedir} 2>&1 | tee BUILD-DETAILS

SHAREDIR=$RPM_BUILD_ROOT/$PKGROOT
mkdir -p $SHAREDIR
for thing in `cat share-contents`; do
    if [ -d "$thing" ]; then
        cp -r "$thing" "$SHAREDIR/$thing"
    else
        cp "$thing" "$SHAREDIR/$thing"
    fi
done

%ifarch %{ix86}
triplet=i486-unknown-linux-gnu
archlib=lib
%endif
%ifarch ppc
triplet=ppc-unknown-linux-gnu
archlib=lib
%endif
%ifarch ppc64
triplet=ppc64-unknown-linux-gnu
archlib=lib64
%endif
%ifarch s390
triplet=s390-unknown-linux-gnu
archlib=lib
%endif
%ifarch s390x
triplet=s390x-unknown-linux-gnu
archlib=lib64
%endif
%ifarch ia64
triplet=ia64-unknown-linux-gnu
archlib=lib
%endif
%ifarch x86_64
triplet=x86_64-unknown-linux-gnu
archlib=lib64
%endif

# Create the run_tests file
sed -e "s\\^VERSION=$\\VERSION=%{version}\\" -e "s\\^ARCHLIB=$\\ARCHLIB=$archlib\\" run_tests.in > ${RPM_BUILD_ROOT}/$PKGROOT/run_tests
chmod a+x ${RPM_BUILD_ROOT}/$PKGROOT/run_tests

# Create the context file
sed -e "s\\^V3Test.compiler_output_dir=$\\V3Test.compiler_output_dir=$EXECROOT\\" -e "s\\^DejaGNUTest.target=$\\DejaGNUTest.target=$triplet\\" -e "s\\^VSX_NAME=$\\VSX_NAME=LSB Certification Version 2.0 (%{_target_cpu})\\" context.in > ${RPM_BUILD_ROOT}/$PKGROOT/context

find $LIBDIR -name '*.pyc' -o -name '*.pyo' -print0 | xargs -0 rm -f
find $SHAREDIR -name '*.pyc' -o -name '*.pyo' -print0 | xargs -0 rm -f

%clean
rm -rf $RPM_BUILD_ROOT

%post
echo 
echo Before running the test script, please figure out the triplet for the
echo system under test. Normally you can use \"gcc -dumpmachine\" to get this.
echo The test script will make a guess which is probably okay, correct it
echo if it is not.  This step cannot be automated as a compiler is not
echo required in the test environment and other methods are imprecise.
echo After this, you can run the test by executing 
echo /opt/lsb/test/share/qmtest_libstdcpp_%{version}/run_tests

%files
# Install all files as root:
%defattr(-,root,root)
/opt/lsb/test/share/qmtest_libstdcpp_%{version}/
%ifarch ppc64 s390x x86_64
  /opt/lsb/test/lib64/qmtest_libstdcpp_%{version}/
%else
  /opt/lsb/test/lib/qmtest_libstdcpp_%{version}
%endif
%doc README
%doc PKGINFO
%doc BUILD-DETAILS
%doc executable-gen.qmr
%doc build_v3_dist
%doc build_binary_testsuite

%changelog
* Thu Jul 22 2004 Mats Wichmann <mats@freestandards.org>
- rollup changelog for various issues relating to LSB packaging,
  many from Hong Bo Peng
- created baselines for all LSB architectures
- modified v3_test.py to direct all LSB architectures to that set
- added packaging directory with specfile
- added prototype context file, and a run_tests script to execute

* Mon Apr 19 2004 Nathaniel Smith <njs@codesourcery.com> 
- Fix bug in computation of symbol baseline paths.
- Make package relocatable.
- Document generation of new symbol baseline files.
- Update QMTest-related URLs in README.

* Mon Mar 29 2004 Nathaniel Smith <njs@codesourcery.com> 
- Rework for no-compiler version of testsuite.

* Tue Mar 16 2004 Nathaniel Smith <njs@codesourcery.com> 
- Initial release.

